/***************************************************************************
 *  Copyright (C) 2011 by Resara LLC                                       *
 *  brendan@resara.com                                                     *
 *                                                                         *
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU Lesser General Public License as         *
 *  published by the Free Software Foundation; either version 2 of the     *
 *  License, or (at your option) any later version.                        *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful, but    *
 *  WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
 *  Lesser General Public License for more details.                        *
 *                                                                         *
 *  You should have received a copy of the GNU Lesser General Public       *
 *  License along with this program; if not, write to the                  *
 *  Free Software Foundation, Inc.,                                        *
 *  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 *                                                                         *
***************************************************************************/
#ifndef RDSDHCPMANAGER_H
#define RDSDHCPMANAGER_H

#include <RdsEntityManager>
#include <QxtPimpl>
#include <rdsglobal.h>
#include <QStringList>
#include <QHostAddress>

class RdsDhcpManagerPrivate;
class RdsNtAcl;

/**
@author Brendan Powers <brendan@resara.com>
*/
class RDS_CLIENT_EXPORT RdsDhcpManager : public RdsEntityManager
{
	Q_OBJECT
	QXT_DECLARE_PRIVATE(RdsDhcpManager);
	QTRPC_CLIENTPROXY_PIMPL(RdsDhcpManager);
public:
	RdsDhcpManager(QObject *parent = 0);
	RdsDhcpManager(const RdsDhcpManager &other);
	~RdsDhcpManager();

	RdsDhcpManager &operator=(const RdsDhcpManager &other);
	ReturnValue init();

signals:
	ReturnValue save() const;
	ReturnValue reload();
	ReturnValue values() const;
	ReturnValue values(const QString& path) const;
	ReturnValue move(const QString& path, const QString& newpath);
	ReturnValue interfaces();
	ReturnValue setInterfaces(QStringList interfaces);
	ReturnValue enabled();
	ReturnValue setEnabled(bool enabled);
	ReturnValue configured();
	ReturnValue checkRange(const QString &id, const QHostAddress &start, const QHostAddress &end);
	ReturnValue listAllGroups(QString baseid = "");
	ReturnValue listAllSharedNetworks(QString baseid = "");
	ReturnValue listAllSubnets(QString baseid = "");
	ReturnValue listAllHosts(QString baseid = "");
};

#endif
